#-------------------------------------------------------------------------------------------------------
# SieveOC
# &sievelogin(<Pointer>,<ConfigPointer>);
# 
# Input : <Pointer>HashPointer   <ConfigPointer>HashPointer
#           None                   sieve_server   --- Sieve Server
#                                  sieve_port     --- Sieve Port
#                                  sieve_account  --- Sieve Account
#                                  sieve_password --- Sieve Password
#                                  sieve_ssl      --- Sieve over SSL (ssl|"")
# Output: 1 | ErrNum
#
#-------------------------------------------------------------------------------------------------------

return 1;

sub sievelogin{
	
	#---e擾
	(*lib_pointer,*lib_config) = @_;
	
	$sieve_server   = $lib_config{"sieve_server"  };
	$sieve_port     = $lib_config{"sieve_port"    };
	$sieve_account  = $lib_config{"sieve_account" };
	$sieve_password = $lib_config{"sieve_password"};
	$sieve_ssl      = $lib_config{"sieve_ssl"     };
	
	#---Sieve͈ʓI2000ԃ|[g
	if ($sieve_port eq ""){ $sieve_port = "2000";}
	
	#----Sieve ւ TCP/IP ڑ
	($rc,$type,$msg) = &open_tcp_connection($sieve_server,$sieve_port,"SIEVE");
	if ($rc ne "1"){ return('sievelogin->'.$rc,$type,$msg);}
	
	#-----Ready ?
	if ($timeout_time ne ""){ alarm($timeout_time);
	                          $timeout_msg = "TimeOutError (Server not ready)";}
	($rc,$out) = &sieve_rc();
	if ($rc ne "OK"){ &execute('sievelogout','1');
	                  return('sievelogin','sieveready',$rc."\n".$out);}
	
	#---T[o[Xe[^X
	if ($timeout_time ne ""){ alarm($timeout_time);
	                          $timeout_msg = "TimeOutError (TimeOutError: CAPABILITY Command)";}
	($rc,$out) = &sieve_tr("CAPABILITY\r\n");
	($rc,$out) = &sieve_rc();
	if ($rc ne "OK"){ &execute("sievelogout");
	                  return('sievelogin','capability',$rc."\n".$out);}
	
	$login_mode = 0;
	if (index($out,"CRAM-MD5") >= 0){ $login_mode = 1;}
	if ($sieve_ssl_flag == 1       ){ $login_mode = 0;}
	
	#---LOGIN
	if ($login_mode == 1){
		&sieve_tr("AUTHENTICATE \"CRAM-MD5\"\r\n");
		($rc,$out) = &sieve_rc();
		
		if (substr($rc,0,2) eq "NO"){ $login_mode = 0;}
		else{
			
			$res_key = &execute('sasl','cram-md5',$sieve_account,$sieve_password,$challenge);
			
			&sieve_tr("\"$res_key\"\r\n");
			($rc,$out) = &sieve_rc();
			if ($rc ne "OK"){ $login_mode = 0;}
		}
	}
	if ($login_mode == 0){
		&sieve_tr("AUTHENTICATE \"PLAIN\"\r\n");
		($rc,$out) = &sieve_rc();
		if ($rc ne "OK"){ &execute('sievelogout');
		                  return('sievelogin','login',$rc."\n".$out);}
		
		$res_key = &execute('sasl','plain',$sieve_account,$sieve_password);

		&sieve_tr("\"$res_key\"\r\n");
		($rc,$out) = &sieve_rc();
		if ($rc ne "OK"){ &execute("sievelogout");
		                  return('sievelogin','login',$rc."\n".$out);}
	}
	
	$login_ctl{"sieve"} = 1;
	
	return(1);
	
}
