
#-------------------------------------------------------------------------------
#                           jcode⏕Cu
#                           Ver1.1
#
# jcodeƌp邱ƂŁAUTF-8ϊ@\܂
# ܂AMIMEfR[h@\܂
# ϊe[u(euc-utf8-[1-3].dat sjis-utf8-[1-3].dat)Kvł
#
#-------------------------------------------------------------------------------

package mojicode;

%b64_dec = (
'A', '000000',  'B', '000001',  'C', '000010',  'D', '000011',
'E', '000100',  'F', '000101',  'G', '000110',  'H', '000111',
'I', '001000',  'J', '001001',  'K', '001010',  'L', '001011',
'M', '001100',  'N', '001101',  'O', '001110',  'P', '001111',
'Q', '010000',  'R', '010001',  'S', '010010',  'T', '010011',
'U', '010100',  'V', '010101',  'W', '010110',  'X', '010111',
'Y', '011000',  'Z', '011001',  'a', '011010',  'b', '011011',
'c', '011100',  'd', '011101',  'e', '011110',  'f', '011111',
'g', '100000',  'h', '100001',  'i', '100010',  'j', '100011',
'k', '100100',  'l', '100101',  'm', '100110',  'n', '100111',
'o', '101000',  'p', '101001',  'q', '101010',  'r', '101011',
's', '101100',  't', '101101',  'u', '101110',  'v', '101111',
'w', '110000',  'x', '110001',  'y', '110010',  'z', '110011',
'0', '110100',  '1', '110101',  '2', '110110',  '3', '110111',
'4', '111000',  '5', '111001',  '6', '111010',  '7', '111011',
'8', '111100',  '9', '111101',  '+', '111110',  '/', '111111',
);

$sjis_utf8_1 = './lib/dat/sjis-utf8-1.dat';
$sjis_utf8_2 = './lib/dat/sjis-utf8-2.dat';
$sjis_utf8_3 = './lib/dat/sjis-utf8-3.dat';
$euc_utf8_1  = './lib/dat/euc-utf8-1.dat';
$euc_utf8_2  = './lib/dat/euc-utf8-2.dat';
$euc_utf8_3  = './lib/dat/euc-utf8-3.dat';

#---R[hK\
#$oneUTF8   = '(?:[\x00-\x7F])';
#$utf8_moji = "(?:$oneUTF8|$twoUTF8|$threeUTF8)";
$twoUTF8    = '(?:[\xC0-\xDF][\x80-\xBF])';
$threeUTF8  = '(?:[\xE0-\xEF][\x80-\xBF][\x80-\xBF])';
$utf8_moji  = "(?:$twoUTF8|$threeUTF8)";

$ascii_moji = '\x1b\([BHJ]([\t\x20-\x7e]*)';
$jis_moji   = '\x1b\$[@B](([\x21-\x7e]{2})*)';

$ascii      = '[\x00-\x7F]';                      # 1oCg EUC-JP
$twoBytes   = '(?:[\x8E\xA1-\xFE][\xA1-\xFE])';   # 2oCg EUC-JP
$threeBytes = '(?:\x8F[\xA1-\xFE][\xA1-\xFE])';   # 3oCg EUC-JP
$euc_moji   = "(?:$ascii|$twoBytes|$threeBytes)"; # EUC-JP

$oneByte_sjis  = '[\x00-\x7F\xA1-\xDF]';                         # 1oCg SJIS
$twoBytes_sjis = '(?:[\x81-\x9F\xE0-\xFC][\x40-\x7E\x80-\xFC])'; # 2oCg SJIS
$sjis_moji     = "(?:$oneByte_sjis|$twoBytes_sjis)";             # SJIS



$uni2sjis_f = 0;
$uni2euc_f  = 0;

%uni2sjis_h =();
%uni2euc_h  =();
%sjis2uni_h =();
%euc2uni_h  =();

return 1;

sub convert{
	my($str_f,$code,$org) = @_;
	
	$code = lc($code);
	$org  = lc($org);
	
	if   ($org eq "iso-2022-jp"){ &jcode'convert($str_f,$code,'jis');}
	elsif($code eq "utf-8"     ){
		$org = &jcode'getcode($str_f) if $org eq "";
		if ($org ne "sjis" &&
		    $org ne "euc" ){ &jcode'convert($str_f,"sjis"); $org = "sjis";}
		if ($org eq "sjis"){
			&init('sjis');
			$$str_f =~ s/($sjis_moji)/$sjis2uni_h{$1}/og;
		}else{
			&init('euc');
			$$str_f =~ s/($euc_moji)/$euc2uni_h{$1}/og;
		}
	}
	elsif($org eq "jis"  ||
	      $org eq "sjis" ||
	      $org eq "euc"        ){ &jcode'convert($str_f,$code,$org); }
	elsif($org ne "utf-8"      ){ &jcode'convert($str_f,$code);      }
	else                        {
		if ($code eq "sjis"){
			&init('sjis');
			$$str_f =~ s/($utf8_moji)/$uni2sjis_h{$1}/og;
		}else{
			&init('euc');
			$$str_f =~ s/($utf8_moji)/$uni2euc_h{$1}/og;
		}
	}
}

sub mime_dec{
	
	my($str_f,$code) = @_;
	
	$$str_f =~ s/=\?([^\?]+)\?([^\?]+)\?([^\?]+)\?=/&mime_sub($1,$2,$3,$code)/eg;
	
}
sub mime_sub{
	my($type,$enc,$dat,$code) = @_;
	
	$enc = lc($enc);
	$type= lc($type);
	
	if ($enc eq "b"){ #---Base64
#		$dat =~ s/\=+$//;
		$dat =~ s/(.)/$b64_dec{$1}/g;
#		$dat = join('', @b64_dec{split(//, $dat)});
		$dat = pack("B".(length($dat)>>3<<3), $dat);
	}else{                #---Quoted-Printable
		$dat =~ s/=([0-9A-Fa-f]{2})/pack("C",hex($1))/ge;
	}
	
	if   ($type eq 'iso-2022-jp'){
		&jcode'convert(\$dat,$code,'jis');
	}elsif($type eq 'shift-jis'){
		&jcode'convert(\$dat,$code,'sjis');
	}elsif($type eq 'euc-jp'){
		&jcode'convert(\$dat,$code,'euc');
	}elsif($type eq 'utf-8'      ){ 
		if ($code eq "sjis"){
			&init('sjis');
			$dat =~ s/($utf8_moji)/$uni2sjis_h{$1}/og;
		}else{
			&init('euc');
			$dat =~ s/($utf8_moji)/$uni2euc_h{$1}/og;
		}
	}
	return($dat);
}

sub init{
	
	my($moji) = $_[0];
	
	if ($moji eq "sjis"){
		$use_db1   = $sjis_utf8_1;
		$use_db2   = $sjis_utf8_2;
		$use_db3   = $sjis_utf8_3;
		*use_flag  = *uni2sjis_f ;
		*use_hash1 = *uni2sjis_h ;
		*use_hash2 = *sjis2uni_h ;
	}else{
		$use_db1   = $euc_utf8_1;
		$use_db2   = $euc_utf8_2;
		$use_db3   = $euc_utf8_3;
		*use_flag  = *uni2euc_f ;
		*use_hash1 = *uni2euc_h ;
		*use_hash2 = *euc2uni_h ;
	}
	
	if ($use_flag == 0){
		@item1 = (1,2,2);
		@item2 = (1,2,3);
		@item3 = (2,4,5);
		foreach $a ($use_db1,$use_db2,$use_db3){
			$r1=shift(@item1);
			$r2=shift(@item2);
			$r3=shift(@item3);
			
			open(IN,$a);
			binmode IN;
			$db_size = -s $a;
			$size = 0;
			while($size <= $db_size){
				read(IN,$t  ,$r1);
				read(IN,$uni,$r2);
				$size += $r3;
				$use_hash1{$uni} = $t;
				$use_hash2{$t  } = $uni;
			}
			close(IN);
		}
		$use_flag = 1;
	}
	return(1);
}

